package seu.agent.Ambulance;

import java.util.ArrayList;
import java.util.Collection;
import java.util.EnumSet;
import java.util.HashSet;
import java.util.List;

import rescuecore2.messages.Command;
import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Civilian;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.ChangeSet;
import rescuecore2.worldmodel.EntityID;
import seu.agent.DecisionManager;
import seu.agent.SEUAgent;
import seu.agent.BasicTask.BasicTask;
import seu.agent.BasicTask.ExplorationoutofpartionTask;
import seu.agent.BasicTask.ExplorationoutofpartionTask;
import seu.agent.BasicTask.ExploreinpartionTask;
import seu.agent.BasicTask.IsStuckOrBuriedCallHelpTask;
import seu.agent.BasicTask.PartitionExplorationTask;
import seu.agent.BasicTask.RandomWalkTask;
import seu.agent.BasicTask.SaveCivAndAgentTask;
import seu.agent.BasicTask.SaveHuman;
import seu.agent.BasicTask.SaveMyselfTask;
import seu.agent.BasicTask.State;
import seu.agent.BasicTask.StayInPartitionTask;
import seu.agent.BasicTask.StuckInRoadTask;
import seu.message.MessagePriority;
import seu.message.Type.AgentIsBuriedMessage;
import seu.message.Type.BuildingIsExploredMessage;
import seu.message.Type.BuildingMaybeMessage_at;
import seu.message.Type.CivilianInformationMessage;
import seu.message.Type.CivilianIsSavedOrDeadMessage;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.message.Type.Message;
import seu.message.Type.MessageCount;
import seu.message.Type.MessageType;
import seu.utilities.Path;
import seu.utilities.Search.Cost.PathType;

import java.awt.Point;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.EnumSet;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;

import rescuecore2.Constants;
import rescuecore2.config.Config;
import rescuecore2.messages.Command;
import rescuecore2.misc.Pair;
import rescuecore2.misc.geometry.GeometryTools2D;
import rescuecore2.misc.geometry.Line2D;
import rescuecore2.misc.geometry.Point2D;
import rescuecore2.standard.components.StandardAgent;
import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Civilian;
import rescuecore2.standard.entities.Edge;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.PoliceForce;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityConstants.Fieryness;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.entities.StandardPropertyURN;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.standard.messages.AKSpeak;
import rescuecore2.worldmodel.ChangeSet;
import rescuecore2.worldmodel.Entity;
import rescuecore2.worldmodel.EntityID;
import rescuecore2.worldmodel.Property;
import seu.agent.BasicTask.BasicTask;
import seu.agent.BasicTask.ClearPath;
import seu.agent.BasicTask.State;
import seu.agent.command.seuClear;
import seu.agent.command.seuCommand;
import seu.agent.command.seuLoad;
import seu.agent.command.seuMove;
import seu.agent.command.seuMoveXY;
import seu.agent.command.seuRescue;
import seu.agent.command.seuRest;
import seu.agent.command.seuUnload;
import seu.config.Configuration;
import seu.message.CommunicationCondition;
import seu.message.MessageController;
import seu.message.MessageMemory;
import seu.message.MessagePriority;
import seu.message.MessageTranslator;
import seu.message.QueueMessage;
import seu.message.messageKeeper;
import seu.message.Type.AgentIsBuriedMessage;
import seu.message.Type.AgentPositionMessage;
import seu.message.Type.BuildingIsBurningMessage;
import seu.message.Type.BuildingIsExploreMessage_at;
import seu.message.Type.GasStationIsBurningMessage;//niu
import seu.message.Type.BuildingCloseToGasStationIsBurningMessage;//niu
import seu.message.Type.BuildingIsExploreMessage_fb;
import seu.message.Type.BuildingIsExploreMessage_pf;
import seu.message.Type.BuildingIsExploredMessage;
import seu.message.Type.BuildingIsExtinguishedMessage;
import seu.message.Type.ChannelCondition;
import seu.message.Type.CivilianInformationMessage;
import seu.message.Type.CivilianIsSavedOrDeadMessage;
import seu.message.Type.CivilianMaybeMessage;
import seu.message.Type.ClearPathReason;
import seu.message.Type.InformTeamMessage;
import seu.message.Type.Message;
import seu.message.Type.MessageCount;
import seu.message.Type.MessageType;
import seu.message.Type.PartitionAssignmentMessage;
import seu.message.newPart.MessageCount1;
import seu.message.newPart.MessageCount2;
import seu.message.newPart.MessageCount3;
import seu.message.newPart.MessageCount4;
import seu.message.newPart.MessageCount5;
import seu.message.newPart.MessageCount6;
import seu.message.newPart.MessageCount7;
import seu.message.newPart.MessageCount8;
import seu.message.newPart.MessageCount9;
import seu.object.Exploration;
import seu.object.SEUWorldModel;
import seu.object.Building.BuildingInfo;
import seu.object.Partition.EntityInPartition;
import seu.object.Partition.GroupingType;
import seu.object.Partition.PartitionMap;
import seu.object.Road.MultiBlockDistanceComparator;
import seu.object.Road.RoadInfo;
import seu.object.Road.RoadUtilities;
import seu.utilities.ACAMainRoad;
import seu.utilities.DistanceComparator;
import seu.utilities.FireSite;
import seu.utilities.Path;
import seu.utilities.PositionHistory;
import seu.utilities.PredictDamageTool;
import seu.utilities.Geometry.PositionLocate;
import seu.utilities.Search.AbstractSearch;
import seu.utilities.Search.AStar.AStarSearch;
import seu.utilities.Search.Cost.PathType;


/**
 * SEU's Ambulance Team Agent.
 */
public class SEUAmbulanceTeam extends SEUAgent<AmbulanceTeam> {

	private SaveCivAndAgentTask saveCivilianTasks;
	private SaveCivAndAgentTask saveAgentTask;

	public SEUAmbulanceTeam() {
		super();
	}

	@Override
	public String toString() {
		return "SEU Ambulance Team #" + getNo() + " " + super.toString();
	}

	@Override
	protected void postConnect() {
		super.postConnect();
		new HashSet<EntityID>();

	}

	@Override
	protected EnumSet<StandardEntityURN> getRequestedEntityURNsEnum() {
		return EnumSet.of(StandardEntityURN.AMBULANCE_TEAM);
	}

	protected void processMessage(MessageCount message) {
		int counter = message.getCounter();
		MessageCount reply = new MessageCount(counter + 1);
		sendMessage(reply, MessagePriority.High);
	}

	@Override
	protected void thinkAndAct() {
	}
	
	@Override
	protected void think(int time, ChangeSet changed, Collection<Command> heard){//niu
		super.think(time, changed, heard);
     //  if(time==3)
		//updatesaveAgentTask();
		
	}

//	void processBuildingMaybeMessage_at(BuildingMaybeMessage_at message) {
//		//System.err.println("timeStep"+this.timeStep+"BuildingMaybeMessage_at");
//		 for(int i=0;i<message.getCivilianMayInBuildingId().length;i++){
//			 //这里似乎有问题，消息一直都只有一个，输出的长度永远都只为一
//		 StandardEntity s = world.getEntity(message.getCivilianMayInBuildingId()[i]);
//		 //看输出，这里什么时候存成数组了
//		 //System.out.println("message.getCivilianMayInBuildingId()"+message.getCivilianMayInBuildingId().length);
//		if (s instanceof Building) {
//			Building b = (Building) s;
//			StandardEntity a=world.getEntity(this.getLocation(timeStep));
//			//if(this.isInMyPartition(b)){
//		if(((world.getObjectsInRange(a, 30000)).contains(b))||(this.isInMyPartition(b))){
//			//if(( world.getObjectsInRange(a, 30000)).contains(b)){
//					if(!temp_maybebuilding.contains(b))
//					temp_maybebuilding.add(b);
//				/*else {
//					Path path= this.getSearch().getPath(this.getMeAsHuman(),
//							b, PathType.Shortest);
//					ClearPathIsNeededMessage mes  = new ClearPathIsNeededMessage(
//							path.getStart(), path.getDestination(),
//							ClearPathReason.ExploreRoad);
//					sendMessage(mes, MessagePriority.High);
//				}*/
//			}	
//		}
//	}
//		 state =State.Exploring;
//		 
//		//System.out.println(timeStep+ " "+this.getID()+ "AT RECEIVE temp_maybebuilding"+temp_maybebuilding );//lblater
//	}
	protected void processExplorationMessage (BuildingIsExploreMessage_at  message) {
		EntityID e = message.getBuildingId();
		StandardEntity s = world.getEntity(e);
		if (s instanceof Building) {
			Building b = (Building) s;
//			if (maybebu .contains(b))
//				maybebu .remove(b);
			if (nofoundbuilding.contains(b))
				nofoundbuilding.remove(b);
		}
	}

	@Override
	protected void processMessage(Message message) {
		
			if (message instanceof BuildingIsExploreMessage_at) {
				
				//System.out.println("time  " + timeStep + "AT receive  Message 1");
				BuildingIsExploreMessage_at explorationMessage = (BuildingIsExploreMessage_at) message;
				processExplorationMessage(explorationMessage);
			}
         if (message instanceof BuildingIsExploredMessage ) {
				
				//System.out.println("time  " + timeStep + "AT receive  Message 1");
				BuildingIsExploredMessage  explorationMessage = (BuildingIsExploredMessage ) message;
				processExplorationMessage(explorationMessage);
			}
//			if (message instanceof BuildingMaybeMessage_at) {///lb
//				 
//				BuildingMaybeMessage_at buildingmaybeMessage = (BuildingMaybeMessage_at) message;
//				processBuildingMaybeMessage_at(buildingmaybeMessage);
//				 
//
//			}
//			if (message instanceof HumanIsSavingMessage) {     //////wan
//				HumanIsSavingMessage humanisSavingMessage=(HumanIsSavingMessage) message;
//				processHumanIsSavingMessage(humanisSavingMessage);
//			}
			
			if (message instanceof CivilianInformationMessage) {//System.out.println("time  " + timeStep + "AT receive  Message 2");
				CivilianInformationMessage civilianInformationMessage = (CivilianInformationMessage) message;
				processCivilianInformationMessage(civilianInformationMessage);
				//System.out.println("CivilianInformationMessage");
			}
			if (message instanceof CivilianIsSavedOrDeadMessage) {//System.out.println("time  " + timeStep + "AT receive  Message 3");
				CivilianIsSavedOrDeadMessage civilianIsSavedMessage = (CivilianIsSavedOrDeadMessage) message;
				processCivilianIsSavedMessage(civilianIsSavedMessage);
			}
			if (message instanceof AgentIsBuriedMessage) {//System.out.println("time  " + timeStep + "AT receive  Message 4");
				AgentIsBuriedMessage agentIsBuriedMessage = (AgentIsBuriedMessage) message;
				processAgentIsBuriedMessage(agentIsBuriedMessage);
				//System.out.println("AgentIsBuriedMessage");
			}
			if (message instanceof AgentPositionMessage) {
				AgentPositionMessage agentPositionMessage = (AgentPositionMessage) message;
				processAgentPositionMessage(agentPositionMessage);
			}
		
	}
//	protected void processHumanIsSavingMessage(HumanIsSavingMessage message){ //////wan
// 
//		 System.out.println("processHumanIsSavingMessage");
//		if(!saveCivilianTasks.getsaveHumanTasks().isEmpty()){
//			
//		 for(SaveHuman next:saveCivilianTasks.getsaveHumanTasks()){
//			 System.out.println("kong");
//			if(next.getHumanId().equals(message.getHumanId())) {
//				next.DeleteoneAT(); 
//				 System.out.println("next.DeleteoneAT()");
//			}
//		 }
//		}
//		if(!saveAgentTask.getsaveHumanTasks().isEmpty()){
//			
//			for(SaveHuman next:saveAgentTask.getsaveHumanTasks()){
//				System.out.println("kong");
//				if(next.getHumanId().equals(message.getHumanId()) ){
//					next.DeleteoneAT(); 
//					 System.out.println("next.DeleteoneAT()");
//				}
//			 }
//		}
//		 
	//}
	protected void processCivilianInformationMessage(
			CivilianInformationMessage message) {
		 try{
		EntityID location = new EntityID(message.getLocationId());
		StandardEntity civilianLocation = world.getEntity(location);
		StandardEntity civilian1  = world.getEntity(message.getCivilianId());
		int X=civilianLocation.getLocation(world).first() ;
		int Y=civilianLocation.getLocation(world).second();
		
		Civilian civilian = new Civilian((message.getCivilianId()));
		civilian.setHP(message.getHp());
		civilian.setDamage(message.getDamage());
		civilian.setBuriedness(message.getBuriedness());
       
		int deathTime =  
				 Math.min(DecisionManager.getDeathTime(civilian,getTimeStep()),gettimeforfire(civilian)) ; //// wan
//		int ATs= (int) ( message.getBuriedness()/(deathTime-
//				rescuerange()/5000-getNearestdistorefuge(civilian)/31445.392))+1;
		 double cost=1+0.9*getNearestdistorefuge(civilian)/31445.392
				    +1.5*world.getDistance(civilianLocation, me().getPosition(world))/31445.392
				 +   2.7*getdistoceterofpartion(X,Y)/31445.392
				    -1.5*100/(message.getBuriedness()*Math.ceil(message.getHp()/(double)message.getDamage()*0.8)+1);          
		SaveHuman saveCivilianTask = new SaveHuman(civilian, civilianLocation,
				deathTime,cost);
		int dis = world.getDistance(me().getID(), location);
		

//		 Path path =getPathToPartition();
		 if(saveCivilianTasks!=null &&dis<=rescuerange())
			 saveCivilianTasks.addSaveTask(saveCivilianTask);
		 
		
		
//		if(saveCivilianTasks!=null&&(isInMyPartition(me().getPosition(world)))
//				&&dis<= rescuerange())
//			saveAgentTask.addSaveTask(saveCivilianTask);	
		 
		 if(saveCivilianTasks!=null &&isInMyPartition(civilianLocation ))                        //// wan 
				saveCivilianTasks.addSaveTask(saveCivilianTask);
		 if(saveCivilianTasks!=null&&isbuildinginpartiontraversed())	 /////考虑是不是要加一个范围
			saveCivilianTasks.addSaveTask(saveCivilianTask);
		 }catch(Exception e){
			 System.out.println("civilian location is null");}
		
	}

	protected void processAgentIsBuriedMessage(AgentIsBuriedMessage message) {
		try{
		EntityID location = new EntityID(message.getLocationId());
		StandardEntity agentLocation = world.getEntity(location);
		Human agent;

		agent = world.getEntity(
				transidnewtoold(message.getAgentId().getValue()), Human.class);
		if (agent != null) {
			agent.setHP(message.getHp());
			agent.setDamage(message.getDamage());
			agent.setBuriedness(message.getBuriedness());
			StandardEntity agent1  = world.getEntity( message.getAgentId());
			int X= agentLocation.getLocation(world).first() ;
			int Y= agentLocation.getLocation(world).second();
			
			int deathTime =  
					 Math.min(DecisionManager.getDeathTime(agent,getTimeStep()),gettimeforfire(agent)) ; //// wan
//			int ATs= (int) ( message.getBuriedness()/(deathTime-
//					rescuerange()/5000))+1;  ////最小死亡时间-到最近refuge的距离-大概到达伤者的距离
		   double cost= 1
				   //+0.9*getNearestdistorefuge(agent)/31445.392
				    +1.5*world.getDistance(agentLocation, me().getPosition(world))/31445.392
				    +2.7*getdistoceterofpartion(X,Y)/31445.392
				    -1.5*100/(message.getBuriedness()*Math.ceil(message.getHp()/(double)message.getDamage()*0.8)+1);
			SaveHuman saveHumanTask = new SaveHuman(agent, agentLocation,
					deathTime, cost );

			int dis = world.getDistance(me().getID(), location);
			
//			 Path path =getPathToPartition();
//			 
			 if(saveAgentTask!=null&&dis<= rescuerange()){
				  saveAgentTask.addSaveTask(saveHumanTask);
				 // System.out.println( "dis<= rescuerange"+message.getLocationId());
			 }
				
			
			if (saveAgentTask!=null&& isInMyPartition(agentLocation) )               // wan 14.3
			    {
						 saveAgentTask.addSaveTask(saveHumanTask);
						 
				//System.out.println( "isInMyPartition(agentLocation)"+message.getLocationId());
					}
					 
				 if(saveAgentTask!=null&&isbuildinginpartiontraversed()&&dis<= 3*rescuerange())	                /// wan 14.3 扩大救援范围
				 { saveAgentTask.addSaveTask(saveHumanTask); 
				// System.out.println("isbuildinginpartiontraversed()"+message.getLocationId());
				 }
 					
 	   }
		}catch(Exception e){}
	}

	public void processCivilianIsSavedMessage(
			CivilianIsSavedOrDeadMessage message) {
		EntityID civilianId = (message.getCivilianId());
		if (saveCivilianTasks != null) {

			saveCivilianTasks.removeSaveTask(civilianId);
			// System.out.println("time  " + timeStep + "  agent  " + getID()
			// + "   saveciviliantasks   " + civilianId);
		}

		StandardEntity e = world
				.getEntity(message.getCivilianId(), Human.class);
		if (e == null) {
			// Civilian civilian = new Civilian(message.getCivilianId());
			// civilian.setHP(0);
			// merge(civilian);
		} else {
			Human h = (Human) e;
			h.setHP(0);
			foundCivilians.remove(e.getID());
		}
	}

	@Override
	protected boolean canRescue() {
		return true;
	}

	@SuppressWarnings({ "rawtypes" })
	@Override
	public List<BasicTask> getAgentTasks() {
		List<BasicTask> tasks;

		tasks = new ArrayList<BasicTask>();
		
		tasks.add(new IsStuckOrBuriedCallHelpTask(this));
		tasks.add(new SaveMyselfTask(this));
		tasks.add(new StuckInRoadTask(this));
		// saveAgentTask = new SaveAgentTask(this, true);
		// tasks.add(saveAgentTask);
		//
		// saveCivilianTasks = new SaveCivilianTask(this, false);
		// tasks.add(saveCivilianTasks);
		//tasks.add(new StayInPartitionTask(this));
		saveAgentTask = new SaveCivAndAgentTask(this, true);
		tasks.add(saveAgentTask);

		saveCivilianTasks = new SaveCivAndAgentTask(this, false);
		tasks.add(saveCivilianTasks);
		//tasks.add(new StayInPartitionTask(this));
		
			//System.err.println("at is process");
		tasks.add(new ExploreinpartionTask(this));  /// /wan14.3
		tasks.add(new ExplorationoutofpartionTask(this));/////  wan
		 
		//tasks.add(new StayInPartitionTask(this));
	 
		
		tasks.add(new RandomWalkTask(this));

		return tasks;
	}
	 
	@Override
	public List<MessageType> getMessagesToListen() {
		List<MessageType> types;

		types = new ArrayList<MessageType>();
		types.add(MessageType.AgentIsBuriedMessage);
		types.add(MessageType.AgentPositionMessage);//niu
		types.add(MessageType.CivilianInformationMessage);
		types.add(MessageType.CivilianIsSavedOrDeadMessage);
		types.add(MessageType.BuildingIsExploreMessage_at);            ////wan
		types.add(MessageType.BuildingIsExploredMessage);  
		types.add(MessageType.BuildingIsBurningMessage);
		types.add(MessageType. GasStationIsBurningMessage);//niu
		types.add(MessageType. BuildingCloseToGasStationIsBurningMessage);//niu
		types.add(MessageType.BuildingIsExtinguishedMessage);
		types.add(MessageType.CivilianIsSavedOrDeadMessage);
		types.add(MessageType.CivilianIsSavedOrDeadMessage);
	//	types.add(MessageType.BuildingMaybeMessage_at);
	//	types.add(MessageType.HumanIsSavingMessage);  ////wan
		
		return types;
	}
	
	public void updatesaveAgentTask(){
		 
		  
		 
		  for(EntityID next:ATFirstTasks){
			  
			  
			  Human agent;
			  agent = world.getEntity(next, Human.class);
			  
			 if(agent!=null)  {
				 
				StandardEntity agentLocation = world.getEntity(agent.getPosition());
			  int deathTime = 100;
			  double cost1=1;
			  
			  SaveHuman saveHumanTask = new SaveHuman(agent, agentLocation,
						deathTime, cost1 );
			 
			 int dis = world.getDistance(me().getID(), agentLocation.getID() );

		 
			 if(saveAgentTask!=null&&dis<= rescuerange()){
				 saveAgentTask.addSaveTask(saveHumanTask);
				// System.out.println(getID()+"    11111111111111   "+saveHumanTask.getHumanId());
			 }
				 
			
			if (saveAgentTask!=null&& isInMyPartition(agentLocation) )               // wan 14.3
			    {
						 saveAgentTask.addSaveTask(saveHumanTask);
					// System.out.println(getID()+"    22222222222222   "+saveHumanTask.getHumanId());	 
					}
					 
				 if(saveAgentTask!=null&&isbuildinginpartiontraversed()&&dis<= 3*rescuerange())	                /// wan 14.3 扩大救援范围
				 { 
					 saveAgentTask.addSaveTask(saveHumanTask); 
					// System.out.println(getID()+"    333333333333333   "+saveHumanTask.getHumanId());
				 }
			 }
		  
		  
		  }

}


 }

