package seu.agent.BasicTask;

import java.util.List;

import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.GasStation;
import rescuecore2.standard.entities.Hydrant;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUAgent;
import seu.agent.Firebrigade.SEUFireBrigade;
import seu.agent.Police.SEUPoliceForce;
import seu.message.MessagePriority;
import seu.message.Type.CivilianIsSavedOrDeadMessage;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.message.Type.GasStationIsBurningMessage;
import seu.message.Type.Message;
import seu.object.SEUWorldModel;
import seu.object.Building.BuildingInfo;
import seu.utilities.Path;
import seu.utilities.Search.Cost.PathType;

public class CheckGasStationTask extends BasicTask<SEUAgent<? extends StandardEntity>> {
	//public class CheckGasStationTask extends BasicTask<SEUFireBrigade>{
	//niu13.10.15
	Path path;
	
	
	protected SEUWorldModel world;
	public CheckGasStationTask(SEUAgent<? extends StandardEntity> agent) {//niuµ÷ÓÃµ«Ð§¹û²»ºÃ
		super(agent);
		
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
	}

	@Override
	public boolean shouldExecute() {
		if ( agent.getTimeStep()%20<5 &&
				 (agent.getMeAsHuman() instanceof FireBrigade)
				 
				//&&( state!= State.MovingToHydrant || state != State.MovingToRefuge || state != State.Extinguishing)
				) {
			FireBrigade fb=(FireBrigade)agent.me();
			if(fb.getWater()>500  ){
			if(agent.getAllGasStations()==null){//niu13.10.16 Ã»reguge
				return false;
			}
			Path path;
			//for(GasStation g:agent.getAllGasStations()){
				//if(agent.isInMyPartition(g) || agent.isInNeighborPartition(g)){//niu14.3.27  ·ÖÇøÄÚ???ÓÐÎÊÌâ
					path = agent.getPathToGasStation();
					// if (35380 == agent.getID().getValue())
					// System.err.println("1" + path);
					if (path == null) {//niu 14.4.3
						
						//ClearPathIsNeededMessage message = new ClearPathIsNeededMessage(
						//		path.getStart(), path.getDestination(),
						//		ClearPathReason.ExtinguishFire);

						//agent.sendMessage(message, MessagePriority.High);
					}
					if (path != null && path.isPassable() ) {//                    niu14.4.2µãÊý¿ØÖÆ
						//if(path.getDestination(world)!=null
						//		&& path.getDestination(world) instanceof Building){
						//Building g=(Building)path.getDestination(world);
						//BuildingInfo gs=new BuildingInfo(g);
						//if(!gs.getGSisExploded()){  // ÆøÕŸ±¬Õš niu14.4.4
						this.path = path;
						state = State.MovingToGasStation;
						return true;
						//}else{
						//	return false;
						//}
					//}
					} else if (path != null && path.hasInfiniteCost()) {
						path = agent.getPathToGasStation(PathType.Shortest);
						// if (35380 == agent.getID().getValue())
						// System.err.println("2" + path);
						if (path != null && path.isPassable()) {
							ClearPathIsNeededMessage message = new ClearPathIsNeededMessage(
									path.getStart(), path.getDestination(),
									ClearPathReason.ExtinguishFire);
							agent.sendMessage(message, MessagePriority.High);
						}
					}
					
				//}
			//}
			
		
			
		}

		// System.err.println("No Path Found in " + agent.getTimeStep());

		return false;
		}
		return false;
	
	}


	@Override
	public void execute() {
		
		//System.out.println("checkGS "+"agentid "+agent.getID() + path.getEntities());
		agent.sendMove(path);
	}

}
