package seu.agent.BasicTask;

import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardEntity;
import seu.agent.SEUAgent;
import seu.agent.Police.SEUPoliceForce;
import seu.message.MessagePriority;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.utilities.Path;
import seu.utilities.Search.Cost.PathType;

public class ClearRaodToFireTask extends
BasicTask<SEUAgent<? extends StandardEntity>> {//13.10.15

Path path;

public ClearRaodToFireTask(SEUAgent<? extends StandardEntity> agent) {
super(agent);
}

@Override
public boolean shouldExecute() {
if (agent instanceof SEUPoliceForce && agent.getTimeStep()%10==7
		&&(state == State.Inactive || state == State.Exploring ||state == State.ExploringRandom)) {
	Path path;
	path = agent.getPathToFire();
	
	// if (35380 == agent.getID().getValue())
	// System.err.println("1" + path);
	
	
		if (path != null) {
			this.path = path;
			state = State.ClearingPath;
			return true;
		} else {
			return false;
		}
	
	
}

// System.err.println("No Path Found in " + agent.getTimeStep());

return false;
}

@Override
public void execute() {
agent.sendMove(path);
//if(agent.getID().getValue()==327290976)
//	System.out.println(agent.getID()+"   "+agent.getTimeStep()+"   clearraodtofiretask   execute");
}

@Override
public void taskDone() {
state = State.Inactive;
path = null;
}


}
