package seu.agent.BasicTask;
import java.awt.Point;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Edge;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUAgent;
import seu.agent.Firebrigade.SEUFireBrigade;
import seu.object.SEUWorldModel;
import seu.object.Building.BuildingFirenessComparator;
import seu.object.Building.BuildingInfo;
import seu.object.Building.BurningBuildingComparator;
import seu.utilities.DistanceComparator;
import seu.utilities.Path;
import seu.utilities.Geometry.PositionLocate;
import seu.utilities.Search.Cost.PathType;
public class ExtinguishImportantBuildingsTask extends BasicTask<SEUFireBrigade>  {//unused
	
	
		protected SEUWorldModel model;
		Path path;
		Building building;
		List<Building> TubaoBuilding;
		Building lastBuilding;

		public ExtinguishImportantBuildingsTask (SEUFireBrigade agent, List<Building> tubaobuilding) {
			super(agent);
			this.TubaoBuilding = tubaobuilding;
			lastBuilding = null;
		}

		@Override
		public void taskDone() {
			state = State.Inactive;
		}

		@Override
		public boolean shouldExecute() {
			State state;
			state = getExpectedState();
			if (agent.me().getWater() == 0
					||agent.getID().getValue()%3!=0 || agent.getTimeStep()%15>=7){//niu
				return false;
			}
			if (state == null || state == State.Inactive) {
				state = State.Inactive;
				// lastBuilding = null;
				return false;
			} else {
				this.state = state;
				return true;
			}
		}

		@Override
		public void execute() {
			if (state == State.MovingToImporBuild) {//niu
				System.out.println(agent.getTimeStep()+"MovingToimpor "+"id "+agent.getID());
				agent.sendMove(path);
			} else if (state == State.Extinguishing) {
				System.out.println(agent.getTimeStep()+"extinguish impor"+"id "+agent.getID());
				lastBuilding = building;
				agent.sendExtinguish(building);
				
			}
		}

		public Building choose() {
			return null;
		}

		
		public State other() {
			lastBuilding = null;
			List<Building> burningSeenBuildings, extinguishableBuildings, allBurningBuildings,importantBuildings;
			//List<Building> TubaoBuilding=new ArrayList<Building>();
			Path path,path1;
			/*
			//if(agent.getID().getValue()%3!=0){
			importantBuildings=new ArrayList<Building>();
			try{
			for(Building b: agent.getBurningBuildings()){
				if(b.getImportance()>1 && b.isFierynessDefined() ){//niu14.3.27 
				    
					BuildingInfo buildinginfo=model.getBuildingInfo(b.getID());
					System.out.println("gengxinshijian !!!!   "+ buildinginfo.getLastUpdateTime());
					if(b.getFieryness()<3  && agent.getTimeStep()-buildinginfo.getLastUpdateTime()<5){//niu14.4.1更新时间
					importantBuildings.add(b);
					
					}else{
						b.setImportance(1);
					}
				    
					}
			}
			}catch (Exception e) {
				// TODO: handle exception
			}
			if (  agent.getBurningBuildings().size()>10 
					&& agent.getTimeStep()%10<5) {//niu 14.4.2
				
				//System.out.println("time"+agent.getTimeStep() +"diaoyongtubao!!!   ");
				TubaoBuilding.clear();
				TubaoBuilding=agent.getTubaoBuilding();
				try{
				if(!TubaoBuilding.isEmpty()){
				for(Building tubaobuilding:TubaoBuilding){
					//System.out.println("tubao jiaru extinguishableBuildings!!!   ");
					tubaobuilding.setImportance(3);
					BuildingInfo buildinginfo=model.getBuildingInfo(tubaobuilding.getID());
					buildinginfo.setLastUpdateTime(agent.getTimeStep());
					importantBuildings.add(tubaobuilding);
				}
				}
				}catch(Exception e){}
			}
			*/
		
			if(!TubaoBuilding.isEmpty()){
				System.out.println("time"+agent.getTimeStep() +"!!!       zhongyaofangwu      !!!   ");
				burningSeenBuildings = agent.getObserveBuilding();
				// getBurningBuildingsFromChangeSet(false,
				// noInferno);
				extinguishableBuildings = new ArrayList<Building>();
			
				if (!burningSeenBuildings.isEmpty())
					for (Building burningBuilding : burningSeenBuildings) {
						if (TubaoBuilding.contains(burningBuilding) && 
								agent.canExtinguish(burningBuilding))
							if (burningBuilding.isFierynessDefined())
								if (burningBuilding.getFieryness() > 0
										&& burningBuilding.getFieryness() < 3) {
									extinguishableBuildings.add(burningBuilding);
								}else{//凸包房屋已不可灭 灭附近的niu
									if (!burningSeenBuildings.isEmpty())
										for (Building burningBuilding1 : burningSeenBuildings) {
											if (
													agent.canExtinguish(burningBuilding1))
												if (burningBuilding1.isFierynessDefined())
													if (burningBuilding1.getFieryness() > 0
															&& burningBuilding1.getFieryness() < 3) {
														extinguishableBuildings.add(burningBuilding1);
													}
										}
								}
					}

				if (!extinguishableBuildings.isEmpty()) {
					Area position;

					position = (Area) agent.getMeAsHuman().getPosition(getModel());
					if (position instanceof Building) {
						Building positionBuilding;

						positionBuilding = (Building) position;
						if (extinguishableBuildings.contains(positionBuilding)) {
							building = positionBuilding;
							return State.Extinguishing;
						}
					}
					BurningBuildingComparator comperator;

					comperator = new BurningBuildingComparator(getModel(),
							agent.getTimeStep());
					Collections.sort(extinguishableBuildings,
							new BuildingFirenessComparator());
					//Collections.sort(extinguishableBuildings,
					//		comperator);
					building = extinguishableBuildings.get(0);
					if(agent.canExtinguish(building)){
					return State.Extinguishing;
					}
				}
			
				
			//BurningBuildingComparator comperator1;

			Collections.sort(TubaoBuilding,
					new DistanceComparator(agent.getMeAsHuman(), agent.getModel()));//距离比较？？重要性？？
			path1 = getSearch().getPath(agent.getMeAsHuman(), TubaoBuilding,
					PathType.EmptyAndSafe);
			if (path1 != null && path1.isPassable()) {
				Area destination;
				EntityID previusId;
				Edge edge;

				if (path1.size() > 1) {
					destination = path1.getDestination(getModel());
					if (agent.canExtinguish((Building) destination)) {
						building = (Building) destination;
						return State.Extinguishing;
					}
					Point target, buildingCenter, position;

					previusId = path1.getEntities().get(path1.size() - 2);
					edge = destination.getEdgeTo(previusId);

					target = PositionLocate.getCenter(edge);
					buildingCenter = PositionLocate.getCenter(destination);
					position = PositionLocate.getExtensionPoint(buildingCenter,
							target, (int) (5 * SEUAgent.AGENT_RADIUS));
					path1.setTarget(position);
				}
				this.path = path1;
				if( path1.getDestination(getModel()) instanceof Building){//niu
					Building b =(Building)  path1.getDestination(getModel());
				//if(b.getImportance()==5){//niu凸包房屋
					System.out.println(agent.getID()+"movingto impor= " + b.getImportance() +
							"ID  " + b.getID() );
				//	return State.MovingToGasStation;
				//}
				}
				return State.MovingToImporBuild;
			  }else{
				return State.Inactive;
			  }
			
			}else{
				return State.Inactive;
			}
			
		}

		public State getExpectedState() {
			State s = State.Inactive;
			
			if (s != State.Inactive) {
//				System.out.println("time  " + agent.getTimeStep() + "   id  "
//						+ agent.getID() + " xxx  " + building);
				return s;
			}
			s = other();
			return s;

		}

		

		@Override
		public String toString() {
			// TODO Auto-generated method stub
			return super.toString() + path;
		}

	

}
