package seu.agent.Firebrigade;

import rescuecore2.standard.entities.Building;
import seu.agent.EstimationConstants;

public class BurningBuilding {

	private Building building;
	private int lastUpdatedCycle;
	private int cycleToBeExtingusihed;
	private int cycleToBeBurntOut;

	public BurningBuilding(Building building, int timeStep) {
		this.building = building;
		lastUpdatedCycle = timeStep;
		estimateParameters();
	}

	public void estimateParameters() {
		cycleToBeBurntOut = lastUpdatedCycle
				+ EstimationConstants.DEFAULT_BURNTOUT_TIME;
	}

	public boolean isOnFire() {
		return building.isOnFire();
	}

	public Building getBuilding() {
		return building;
	}

	public int getCycleToBurntOut() {
		return cycleToBeBurntOut;
	}

	public int getCycleToBeEstinguished() {
		return cycleToBeExtingusihed;
	}
}
