package seu.message.Type;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.worldmodel.EntityID;
import seu.message.Property.IntegerProperty;
import seu.message.Property.MessageProperty;
import seu.message.Property.PropertyName;

public class BuildingIsExploreMessage_fb extends Message {

	public BuildingIsExploreMessage_fb() {
		super();
	}

	public BuildingIsExploreMessage_fb(EntityID buildingId) {
		this();
		setEntityId(PropertyName.BuildingId, buildingId);
	}

	@Override
	protected List<MessageProperty<?>> createProperties() {
		List<MessageProperty<?>> properties = new ArrayList<MessageProperty<?>>();
		properties.add(new IntegerProperty(PropertyName.BuildingId, 2));
		return properties;
	}

	public int getbyte() {
		return 2;
	}

	@Override
	public MessageType getType() {
		return MessageType.BuildingIsExploreMessage_fb;
	}

	public EntityID getBuildingId() {
		return getEntityId(PropertyName.BuildingId);
	}
}
