package seu.message.Type;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.worldmodel.EntityID;

import seu.message.Property.IntegerProperty;
import seu.message.Property.MessageProperty;
import seu.message.Property.PropertyName;

public class GasStationIsExtinguishedMessage extends Message {//niu meiyong

	public GasStationIsExtinguishedMessage() {
		super();
	}

	public GasStationIsExtinguishedMessage(EntityID gasStationId, int fieryness) {
		this();
		setEntityId(PropertyName.GasStationId, gasStationId);
		setInteger(PropertyName.Fieryness, fieryness);
	}

	@Override
	protected List<MessageProperty<?>> createProperties() {
		List<MessageProperty<?>> properties = new ArrayList<MessageProperty<?>>();
		properties.add(new IntegerProperty(PropertyName.GasStationId, 2));
		properties.add(new IntegerProperty(PropertyName.Fieryness, 1));
		return properties;
	}

	public int getbyte() {
		return 3;
	}

	@Override
	public MessageType getType() {
		return MessageType.GasStationIsExtinguishedMessage;
	}

	public EntityID getGasStationId() {
		return getEntityId(PropertyName.GasStationId);
	}

	public int getFieryness() {
		return getInteger(PropertyName.Fieryness);
	}
}

