package seu.message.newPart;

import java.util.ArrayList;
import java.util.List;

import seu.message.Property.IntegerProperty;
import seu.message.Property.MessageProperty;
import seu.message.Property.PropertyName;
import seu.message.Type.Message;
import seu.message.Type.MessageType;

public class MessageCount8 extends Message {

	@Override
	protected List<MessageProperty<?>> createProperties() {
		List<MessageProperty<?>> list = new ArrayList<MessageProperty<?>>();
	
		return list;
	}

	public int getbyte() {
		return 0;
	}

	@Override
	public MessageType getType() {
		return MessageType.MessageCount8;
	}

	public MessageCount8() {
		super();
	}

	public MessageCount8(int counter) {
		this();
		setInteger(PropertyName.Counter, counter);
	}
	public void setCounter(int counter) 
	{
		setInteger(PropertyName.Counter, counter);
	}

	public int getCounter() {
		return getInteger(PropertyName.Counter);
	}

	@Override
	public String toString() {
		return "Count(" + getCounter() + ")";
	}
}
