package seu.utilities;

import java.util.Collection;
import java.util.Comparator;

import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.entities.StandardWorldModel;
import seu.agent.BasicTask.SaveHuman;

public class CostComparator implements Comparator<SaveHuman> {
 

 
	 

	/**
	 * Create a DistanceSorter.
	 * 
	 * @param reference
	 *            The reference point to measure distances from.
	 * @param world
	 *            The world model.
	 */
	public CostComparator( ) {
 
	 
	}

	/**
	 * Compares the standard entites according to distance.
	 * 
	 * @param a
	 *            First StandardEntity to compare
	 * @param b
	 *            Second StandardEntity to compare
	 * @return The difference between distances.
	 */

	@Override
	public int compare(SaveHuman human1, SaveHuman human2) {
		 
		
		return (int) Math.ceil(human1.getcost()-human2.getcost()) ;
	}

}
