package seu.utilities;

import java.util.ArrayList;

/**
 * @author hzr 预测damage，种类collapsedasmage和buriedcollapse。firedamage不在此预测范围内
 */
public class PredictDamageTool {
	public ArrayList<Double> damegeCollapse = new ArrayList<Double>();
	public ArrayList<Double> damageBuriedness = new ArrayList<Double>();
	public ArrayList<ArrayList<Double>> dd = new ArrayList<ArrayList<Double>>();
	public ArrayList<ArrayList<Integer>> HP = new ArrayList<ArrayList<Integer>>();
	public ArrayList<Integer> dHP;
	public ArrayList<Double> dDamage;

	public PredictDamageTool() {
		preCalculate();
		// int i, j, k;
		// for (i = 0; i < HP.size(); i++) {
		// System.out.println(HP.get(i).size());
		// for (j = 0; j < HP.get(i).size(); j++) {
		//
		// System.out.print(HP.get(i).get(j) + " ");
		// }
		// System.out.println();
		// }
	}

	public int calculateDeadTime(int Hp, int damage, int timeStep,
			boolean isOnFire) {
		if (damage == 0) {
			// 此处有待修正，因为每次仿真不一定是300周期
			return 300;
		}
		// 着火房屋，粗略估计
		if (isOnFire) {
			return Hp / damage;
		} else {
			return predicDeadtime(Hp, damage, timeStep);
		}
	}

	public void preCalculate() {
		double bury[] = new double[3];
		double collapse[] = new double[2];
		double da[] = new double[6];
		bury[0] = 3;
		bury[1] = 15;
		bury[2] = 100;
		collapse[0] = 2;
		collapse[1] = 10;
		int c, b;
		int k = 0;
		int DT = 300;
		for (b = 0; b < 3; b++) {
			for (c = 0; c < 2; c++) {
				calculate(k, bury[b], collapse[c]);
				k++;
			}
		}
	}

	public ArrayList<ArrayList<Double>> getDamage() {
		return dd;
	}

	public ArrayList<ArrayList<Integer>> getHP() {
		return HP;
	}

	public int predicDeadtime(int iHp, int iDamage, int iTime) {
		int i, j, k;
		if (iTime < 100 && iDamage >= 100)
			return 75 > iHp / iDamage ? iHp / iDamage : 75;
		int min = 300, tempMin = 300;
		int deadTime = 300, tempDeadTime;
		for (i = 0; i < HP.size(); i++) {
			tempMin = 300;
			tempDeadTime = 300;
			for (j = 0; j < HP.get(i).size(); j++) {
				if (HP.get(i).get(j) / 1000 * 1000 == iHp / 1000 * 1000)
					if (Math.abs(j - iTime) < tempMin) {
						tempMin = Math.abs(j - iTime);
						tempDeadTime = HP.get(i).size();
						// System.out.println(tempMin + " " + tempDeadTime + " "
						// + HP.get(i).size() + " " + HP.get(i).get(j)
						// + " " + j);
					}
			}
			if (tempMin < min) {
				deadTime = tempDeadTime;
				min = tempMin;
			}

		}
		if (deadTime > iHp / iDamage)
			deadTime = iHp / iDamage;
		return deadTime;
	}

	public void calculate(int n, double d1, double d2) {
		int i;
		double d = 0;
		dHP = new ArrayList<Integer>();
		dDamage = new ArrayList<Double>();
		dd.clear();
		damegeCollapse.clear();
		boolean flag = false;
		dHP.add(10000);
		for (i = 1; i <= 300; i++) {
			d1 += 0.000035 * d1 * d1 + 0.01 + 0.1;
			d2 += 0.00025 * d2 * d2 + 0.01 + 0.1;
			damageBuriedness.add(d1);
			damegeCollapse.add(d2);
			dDamage.add(d1 + d2);
			if (!flag) {
				if (dHP.get(i - 1) - d1 - d2 > 0)
					dHP.add((int) (dHP.get(i - 1) - d1 - d2));
				else {
					dHP.add((int) (dHP.get(i - 1) - d1 - d2));
					flag = true;
					break;
				}
			}
		}
		HP.add(dHP);
		dd.add(dDamage);
	}
}
