package seu.utils.geo.acc;

import seu.utils.geo.Point;
import seu.utils.geo.Polygon;

/**
 * 
 * @author Fun
 * 
 */
public class VBPair {
	private final Point vertex;
	private Polygon blockade;

	public VBPair(Point vertex, Polygon blockade) {
		this.vertex = vertex;
		this.blockade = blockade;
	}

	public Point vertex() {
		return this.vertex;
	}

	public Polygon blokade() {
		return this.blockade;
	}

	public void setBlockade(Polygon blockade) {
		this.blockade = blockade;
	}

	@Override
	public String toString() {
		return "{" + vertex + "," + blockade + "}";
	}
}