package seu.agent.BasicTask;

import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.PoliceForce;
import rescuecore2.standard.entities.StandardEntity;
import seu.agent.SEUAgent;
import seu.message.MessagePriority;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.object.SEUWorldModel;
import seu.utilities.Path;
import seu.utilities.Search.Cost.PathType;

public class CheckRefugeTask extends BasicTask<SEUAgent<? extends StandardEntity>> {
	//niu13.10.15
	Path path;
	
	
	protected SEUWorldModel world;
	public CheckRefugeTask(SEUAgent<? extends StandardEntity> agent) {
		super(agent);
		
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
		path=null;
	}

	@Override
	public boolean shouldExecute() {
		if (agent.getMeAsHuman() instanceof PoliceForce 
				&& agent.getTimeStep()%20<4
				&&(state == State.Inactive || state == State.Exploring ||state == State.ExploringRandom)
				&&!agent.hasnoRefuge()
				) {
			Path path;
			path = agent.getPathToRefuge();
			// if (35380 == agent.getID().getValue())
			// System.err.println("1" + path);
			if(path!=null && path.size()<15){
				this.path = path;
				state = State.ClearingPath;
			return true;
			}
		}

		// System.err.println("No Path Found in " + agent.getTimeStep());

		return false;
		
	}


	@Override
	public void execute() {
		agent.sendMove(path);
		//System.out.println("checkRefuge "+"id "+agent.getID());
	}

	
	
	
	
}