package seu.agent.BasicTask;

import java.io.Serializable;

@SuppressWarnings("serial")
public abstract class Task implements Serializable {
	/**
	 * Checks whether the given object is equal to itself or not.
	 * 
	 * @param obj
	 *            Given object.
	 * @return Returns true if objects are equal.
	 */
	@Override
	public abstract boolean equals(Object obj);

	@Override
	public int hashCode() {
		// TODO: make hashCode specific for every task type
		return 5;
	}

	public abstract State getState();

}
