package seu.agent.Firebrigade;

import rescuecore2.misc.geometry.Point2D;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.worldmodel.EntityID;
import rescuecore2.worldmodel.WorldModel;

import seu.object.SEUWorldModel;
import seu.utilities.Geometry.DistanceUtilities;
import seu.utils.geo.Point;

import java.util.ArrayList;
import java.util.List;

public class ClusterAnalysis {
	SEUWorldModel  world;
	//List<centre> AllCentres=new ArrayList<centre>();   //cunzhongxin,heduiyingzuming
	List<DataPoint> temDataPoints=new ArrayList<DataPoint>();//diuqide,lingshidedian
	public List<Cluster> startAnalysis(List<DataPoint> DataPoints,int ClusterNum,SEUWorldModel  w){
		//System.out.println("startAnalysis");
		world=w;
    List<Cluster> finalClusters=new ArrayList<Cluster>();
    
    List<Cluster> originalClusters=initialCluster(DataPoints);                                                     
    finalClusters=originalClusters;
    //聚类数过多则合并
    //while(finalClusters.size()>ClusterNum){
    for(int k=0;k<5;k++){
        double min=40000;                                   //改maxvaule
        int mergeIndexA=0;
        int mergeIndexB=0;
        for(int i=0;i<finalClusters.size();i++){
            for(int j=0;j<finalClusters.size();j++){
                if(i!=j){
                    Cluster clusterA=finalClusters.get(i);
                    Cluster clusterB=finalClusters.get(j);

                    List<DataPoint> DataPointsA=clusterA.getDataPoints();
                    List<DataPoint> DataPointsB=clusterB.getDataPoints();

                    for(int m=0;m<DataPointsA.size();m++){
                        for(int n=0;n<DataPointsB.size();n++){
                            double tempDis=getDistance(DataPointsA.get(m),DataPointsB.get(n));
                            if(tempDis!=0 && tempDis<min){                   //距离小于最小，则可合并i,j类
                                min=tempDis;
                                mergeIndexA=i;
                                mergeIndexB=j;
                            }
                        }
                    }
                }
            } //end for j
        }// end for i
        //合并cluster[mergeIndexA]和cluster[mergeIndexB]
        finalClusters=mergeCluster(finalClusters,mergeIndexA,mergeIndexB);    
    }//end while
  
 
    return finalClusters;
    
 }
 private List<Cluster> mergeCluster(List<Cluster> clusters,int mergeIndexA,int mergeIndexB){
     if (mergeIndexA != mergeIndexB) {
         // 将cluster[mergeIndexB]中的DataPoint加入到 cluster[mergeIndexA]
    	 //System.out.println("hebinglei");
         Cluster clusterA = clusters.get(mergeIndexA);
         Cluster clusterB = clusters.get(mergeIndexB);

         List<DataPoint> dpA = clusterA.getDataPoints();
         List<DataPoint> dpB = clusterB.getDataPoints();
try{
         for (DataPoint dp : dpB) {
             DataPoint tempDp = new DataPoint();
             //tempDp.setDataPointName(dp.getDataPointName());
             tempDp.setbuildingid(dp.getbuildingid());
             tempDp.setCluster(clusterA);
             if(!dpA.contains(tempDp)){
             dpA.add(tempDp);
             }
         }
}catch(Exception e){}
         clusterA.setDataPoints(dpA);
        //DataPoint tempCentre=getCentre(clusterA);
     	

         // List<Cluster> clusters中移除cluster[mergeIndexB]
         clusters.remove(mergeIndexB);
     }

     return clusters;
}

// 初始化类簇
private List<Cluster> initialCluster(List<DataPoint> DataPoints){
	//System.out.println("chushihualei ");
    List<Cluster> originalClusters=new ArrayList<Cluster>();
    List<DataPoint> tempDataPoints=new ArrayList<DataPoint>();
    List<DataPoint> tempDataPoints1=new ArrayList<DataPoint>();
    DataPoint tempDataPoint=null;
    for(int i=0;i<DataPoints.size();i++){
    	//DataPoint tempDataPoint=DataPoints.get(i);
    	tempDataPoint=DataPoints.get(i);
        //List<DataPoint> tempDataPoints=new ArrayList<DataPoint>();
        if(!tempDataPoints.contains(tempDataPoint)){
    	tempDataPoints.add(tempDataPoint);
        }

        DataPoint tempDataPoint1=DataPoints.get(i);
        //List<DataPoint> tempDataPoints1=new ArrayList<DataPoint>();
        if(!tempDataPoints1.contains(tempDataPoint1)){
        tempDataPoints1.add(tempDataPoint1);
        }
        //Cluster tempCluster=new Cluster();
        //tempCluster.setClusterName("Cluster "+String.valueOf(i));
        //tempCluster.setDataPoints(tempDataPoints);

        //tempDataPoint.setCluster(tempCluster);
        //originalClusters.add(tempCluster);
    }
    for(int j=0;j<tempDataPoints.size();j++){
    	Cluster tempCluster=new Cluster();
        tempCluster.setClusterName("Cluster "+String.valueOf(j));
        tempCluster.setDataPoints(tempDataPoints);
        tempDataPoint.setCluster(tempCluster);
    	for(int k=0;k<tempDataPoints1.size();k++){
    		double tempDis1=getDistance(tempDataPoints.get(j),tempDataPoints1.get(k));
    		if(tempDis1!=0 && tempDis1<40000 &&   !originalClusters.contains(tempCluster))
    		{
    	        originalClusters.add(tempCluster);	
    		}
    	}
    	//DataPoint tempCentre=getCentre(tempCluster);
    	
    }
    
    
    return originalClusters;
}

//计算两个样本点之间的欧几里得距离
private double getDistance(DataPoint dpA,DataPoint dpB){
     double distance=0;
     double x1=world.getEntity(dpA.getbuildingid()).getLocation(world).first();
     double y1=world.getEntity(dpA.getbuildingid()).getLocation(world).second();
  //   Point2D p1=new Point2D(x1,y1);
     double x2=world.getEntity(dpB.getbuildingid()).getLocation(world).first();
     double y2=world.getEntity(dpB.getbuildingid()).getLocation(world).second();
     //Point2D p2=new Point2D(x2,y2);
     double dx, dy;
		//int d;

		dx = x1 - x2;
		dy = y1- y2;
		distance = (int) Math.hypot(dx, dy);
    // distance=DistanceUtilities.getDistance(p1, p2);
/*
     if (dimA.length == dimB.length) {
         for (int i = 0; i < dimA.length; i++) {
              double temp=Math.pow((dimA[i]-dimB[i]),2);
              
              distance=distance+temp;
         }
         distance=Math.pow(distance, 0.5);
     }
*/
    return distance;
}
//centre 
/*
private  getCentre(Cluster dpA1){
	double x,y,dx,dy;
	
	//double centre={x,y,clustername}
    for(int n=0;n<Clusters.size();n++){
	     double x1=world.getEntity(dpA1.getcivilianid()).getLocation(world).first();
	     double y1=world.getEntity(dpA1.getcivilianid()).getLocation(world).second();
	  
	    
			//int d;

			dx = dx+x1;
			dy = dy+y1;
    }
    x=dx/Clusters.size();
    y=dy/Clusters.size();
    
    return centre;
}
*/
//zhongxinjianjuli,paixu
//bianyi
//suoyouzhongxinduiweijuleidianjulei
}