package seu.agent.Path;

import rescuecore2.worldmodel.EntityID;
import seu.agent.Police.PoliceTaskPriority;

public class RequiredClearPath {
	private EntityID start;
	private EntityID finish;
	private int durationToClear;
	private PoliceTaskPriority importance;

	public RequiredClearPath(EntityID start, EntityID finish,
			int durationToClear, PoliceTaskPriority priority) {
		this.start = start;
		this.finish = finish;
		this.durationToClear = durationToClear;
		this.importance = priority;
	}

	public EntityID getStart() {
		return start;
	}

	public EntityID getFinish() {
		return finish;
	}

	public int getDurationToClear() {
		return durationToClear;
	}

	public PoliceTaskPriority getImportance() {
		return importance;
	}
}
