package seu.message.Type;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.worldmodel.EntityID;
import seu.message.Property.IntegerProperty;
import seu.message.Property.MessageProperty;
import seu.message.Property.PropertyName;

public class HelpSaveHumanMessage extends Message {

	public HelpSaveHumanMessage() {
		super();
	}

	public HelpSaveHumanMessage(EntityID civilianID, EntityID locationID,
			int DeadTime) {
		this();
		setEntityId(PropertyName.LocationId, locationID);
		setEntityId(PropertyName.CivilianId, civilianID);
		this.setInteger(PropertyName.DeadTime, DeadTime / 2);

	}

	@Override
	protected List<MessageProperty<?>> createProperties() {
		List<MessageProperty<?>> properties = new ArrayList<MessageProperty<?>>();
		properties.add(new IntegerProperty(PropertyName.LocationId, 2));
		properties.add(new IntegerProperty(PropertyName.CivilianId, 2));
		properties.add(new IntegerProperty(PropertyName.DeadTime, 1));
		return properties;
	}

	public int getbyte() {
		return 5;
	}

	@Override
	public MessageType getType() {
		return MessageType.HelpSaveHumanMessage;
	}

	public EntityID getCivilianId() {
		return getEntityId(PropertyName.CivilianId);
	}

	public EntityID getLocationId() {
		return getEntityId(PropertyName.LocationId);
	}

	public int getDeadTime() {
		return getInteger(PropertyName.DeadTime) * 2;
	}
}
